(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["react"], factory);
	else if(typeof exports === 'object')
		exports["ReactPlotting"] = factory(require("react"));
	else
		root["ReactPlotting"] = factory(root["React"]);
})(typeof self !== 'undefined' ? self : this, function(__WEBPACK_EXTERNAL_MODULE_2__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _ReactPlotting = __webpack_require__(1);

var _ReactPlotting2 = _interopRequireDefault(_ReactPlotting);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = _ReactPlotting2.default;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = __webpack_require__(2);

var _react2 = _interopRequireDefault(_react);

var _calcUtils = __webpack_require__(3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var ReactPlotting = function (_React$Component) {
    _inherits(ReactPlotting, _React$Component);

    function ReactPlotting(props) {
        _classCallCheck(this, ReactPlotting);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

        _this.handleWheel = _this.handleWheel.bind(_this);
        _this.mouseMove = _this.mouseMove.bind(_this);
        _this.mouseUp = _this.mouseUp.bind(_this);
        _this.mouseDown = _this.mouseDown.bind(_this);

        _this.canvasRef = _react2.default.createRef();
        _this.state = {
            image: {
                loaded: false,
                image: null,
                url: props.imageUrl
            },
            scale: 1,
            displacement: {
                x: 0,
                y: 0
            }
        };
        _this.mouseEvents = {
            isDown: false,
            previousPos: {
                x: 0,
                y: 0
            }
        };
        return _this;
    }

    ReactPlotting.prototype.loadImage = function loadImage() {
        var _this2 = this;

        var img = new Image();
        img.onload = function () {
            _this2.setState({ image: _extends({}, _this2.state.image, { image: img, loaded: true }) });
        };
        img.src = this.state.image.url;
    };

    ReactPlotting.prototype.updateCanvas = function updateCanvas() {
        if (this.canvasRef.current) {
            var canvas = this.canvasRef.current;
            var canvasDimensions = { width: this.props.width, height: this.props.height };
            canvas.height = canvasDimensions.height;
            canvas.width = canvasDimensions.width;
            var ctx = canvas.getContext('2d');
            ctx.clearRect(0, 0, canvas.width, canvas.height);

            if (this.state.image.loaded) {
                var imageDimensions = {
                    width: this.state.image.image.width,
                    height: this.state.image.image.height
                };
                var imageRect = (0, _calcUtils.calculateCenterPosition)(canvasDimensions, imageDimensions);
                imageRect.x += this.state.displacement.x;
                imageRect.y += this.state.displacement.y;

                var scaledImageRect = (0, _calcUtils.calculateScaledPosition)(canvasDimensions, imageRect, this.state.scale);
                ctx.drawImage(this.state.image.image, scaledImageRect.x, scaledImageRect.y, scaledImageRect.width, scaledImageRect.height);

                ctx.strokeStyle = "red";
                ctx.strokeRect(canvasDimensions.width / 2 - 2, canvasDimensions.height / 2 - 2, 4, 4);
            }
        }
    };

    ReactPlotting.prototype.handleWheel = function handleWheel(event) {
        this.setState({ scale: this.state.scale * (1 - event.deltaY / 1000) });
    };

    ReactPlotting.prototype.mouseMove = function mouseMove(event) {
        if (this.mouseEvents.isDown) {
            var diffX = event.x - this.mouseEvents.previousPos.x;
            var diffY = event.y - this.mouseEvents.previousPos.y;
            this.setState({
                displacement: {
                    x: this.state.displacement.x + diffX / this.state.scale,
                    y: this.state.displacement.y + diffY / this.state.scale
                }
            });
            this.mouseEvents.previousPos = { x: event.x, y: event.y };
        }
    };

    ReactPlotting.prototype.mouseUp = function mouseUp(event) {
        this.mouseEvents.isDown = false;
    };

    ReactPlotting.prototype.mouseDown = function mouseDown(event) {
        this.mouseEvents.isDown = true;
        this.mouseEvents.previousPos = { x: event.x, y: event.y };
    };

    ReactPlotting.prototype.componentDidMount = function componentDidMount() {
        window.addEventListener('wheel', this.handleWheel);
        this.canvasRef.current.addEventListener('mousemove', this.mouseMove);
        this.canvasRef.current.addEventListener('mouseup', this.mouseUp);
        this.canvasRef.current.addEventListener('mouseleave', this.mouseUp);
        this.canvasRef.current.addEventListener('mousedown', this.mouseDown);
    };

    ReactPlotting.prototype.componentWillUnmount = function componentWillUnmount() {
        window.removeEventListener('wheel', this.handleWheel);
        this.canvasRef.current.removeEventListener('mousemove', this.mouseMove);
        this.canvasRef.current.removeEventListener('mouseup', this.mouseUp);
        this.canvasRef.current.addEventListener('mouseleave', this.mouseUp);
        this.canvasRef.current.removeEventListener('mousedown', this.mouseDown);
    };

    ReactPlotting.prototype.componentDidUpdate = function componentDidUpdate() {
        if (!this.state.image.loaded) {
            this.loadImage();
        }
        this.updateCanvas();
    };

    ReactPlotting.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
        var nextState = _extends({}, this.state);
        if (nextProps.imageUrl && nextProps.imageUrl != this.state.image.url) {
            nextState.image = {
                loaded: false,
                image: null,
                url: nextProps.imageUrl
            };
            nextState.displacement = { x: 0, y: 0 };
        } else if (nextState.image.loaded) {
            var calculateProportionalDisplacement = function calculateProportionalDisplacement(currDisplacement, currDim, nextDim) {
                if (!currDim || !nextDim) {
                    return currDisplacement;
                }
                return nextDim / currDim * currDisplacement;
            };

            var imageDimensions = {
                width: this.state.image.image.width,
                height: this.state.image.image.height
            };
            var imageRect = (0, _calcUtils.calculateCenterPosition)({ width: this.props.width, height: this.props.height }, imageDimensions);
            var newImageRect = (0, _calcUtils.calculateCenterPosition)({ width: nextProps.width, height: nextProps.height }, imageDimensions);

            if (newImageRect.width != imageRect.width) {
                nextState.displacement.x = calculateProportionalDisplacement(this.state.displacement.x, imageRect.width, newImageRect.width);
            }
            if (newImageRect.height != imageRect.height) {
                nextState.displacement.y = calculateProportionalDisplacement(this.state.displacement.y, imageRect.height, newImageRect.height);
            }
        }
        this.setState(nextState);
    };

    ReactPlotting.prototype.render = function render() {
        return _react2.default.createElement('canvas', { style: { display: 'block' }, ref: this.canvasRef });
    };

    return ReactPlotting;
}(_react2.default.Component);

exports.default = ReactPlotting;

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_2__;

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
var calculateProportion = exports.calculateProportion = function calculateProportion(outerContainer, _ref) {
    var width = _ref.width,
        height = _ref.height;

    var widthProportion = outerContainer.width / width;
    var heightProportion = outerContainer.height / height;
    var proportion = Math.min(widthProportion, heightProportion);
    return proportion;
};

var calculateCenterPosition = exports.calculateCenterPosition = function calculateCenterPosition(outerContainer, container) {
    var proportion = calculateProportion(outerContainer, container);
    var width = container.width * proportion;
    var height = container.height * proportion;
    var correctPos = function correctPos(posParent, pos) {
        return (posParent - pos) / 2;
    };
    return {
        x: correctPos(outerContainer.width, width),
        y: correctPos(outerContainer.height, height),
        width: width,
        height: height
    };
};

var calculateScaledPosition = exports.calculateScaledPosition = function calculateScaledPosition(outerContainer, rect, scale) {
    var applyScaleToPos = function applyScaleToPos(zoomAt, pos, dim) {
        //let dimScale = ((dim * scale) - dim) / 2;
        return zoomAt - (zoomAt - pos) * scale;
    };
    var applyScaleToDim = function applyScaleToDim(dim) {
        return dim * scale;
    };
    return {
        x: applyScaleToPos(outerContainer.width / 2, rect.x, rect.width),
        y: applyScaleToPos(outerContainer.height / 2, rect.y, rect.height),
        width: applyScaleToDim(rect.width),
        height: applyScaleToDim(rect.height)
    };
};

/***/ })
/******/ ]);
});